# Renderable superclass for ZClasses
# overrides the __str__ method to return the results of a "render" DTML method
# if it exists and <a href=objname>objname</a> if it doesn't
# Copyright (C) 1999 by Lalo Martins
# Distributed under the terms of the GNU GPL, version 2 or later

import Acquisition

class Renderable:
    def __str__ (self):
	Request = self.REQUEST
	if Request:
	    try:
		Method = getattr (self, 'render')
	    except AttributeError:
		return '<a href=%s>%s</a>' % (self.__name__, self.title_or_id())
	    return Method (self, Request)
	else:
	    return "Renderable error: no request"
